
import java.awt.Frame;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.MemoryImageSource;

/** Clase que representa a una ventana.
 * @author Lenguajes de Programacion
 */
public class MuestraImagen extends Frame {
	Image img;
	private TextField c;
	private Button b;
	private Lienzo li;
	
	/** Clase que extiende a Panel
	 * Se sobre-escribe el metodo paint de Panel
	 * para que muestre la imagen
	 */
	class Lienzo extends Panel{
		Lienzo(){
			super();
		}		
		public void paint(Graphics g){
			if (img!=null)
			   g.drawImage(img,0,0,this);
		}
	}
	
	/** Constructor
	 */
	public MuestraImagen(){
		
		Panel p = new Panel();
		p.setLayout(new FlowLayout());
		c = new TextField("            ");
		p.add(new Label("Fichero: "));
		p.add(c);
		
		b = new Button("Mostrar");
		p.add(b);
		
		add(p,BorderLayout.NORTH);
		
		li = new Lienzo();		
		add(li,BorderLayout.CENTER);
		
		/* Se registra un objeto que extiende a MouseAdapter
		   para tratar los eventos de raton en el boton.
		   Lo que se hace es cargar y mostrar la imagen
		   que se ha indicado en el campo de texto */
		   
		b.addMouseListener(new MouseAdapter(){
			public void mousePressed(MouseEvent e){
				try{
					InputStream is = new BufferedInputStream(new FileInputStream(c.getText()));
					int dato;
					int cont=0;
					int[] imagen = new int[512*512];
					
					while ((dato=is.read())!=-1){
						int r = dato & 0xff;
						int g = dato & 0xff;
						int b = dato & 0xff;
						imagen[cont] = (255 << 24) | (r << 16) | (g << 8) | b;
						cont++;
					}
					is.close();
					img = createImage(new MemoryImageSource(512,512,imagen,0,512));
					li.repaint();
					
				}catch(IOException ex){
					System.out.println("Error de lectura del fichero");
					ex.printStackTrace();
				}

			}
		});
		
		/* Se registra un objeto que extiende a WindowAdapter
			para tratar los eventos sobre la ventana.
			Cuando se pulse para cerrar la ventana se 
			finaliza la aplicacion */
			
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				System.exit(0);
			}
		});
		
		setSize(700,700);
		show();
		
   }
}
