
/** Clase TablasCorrespondencia
 * @author Lenguajes de Programacion
 */
public class TablasCorrespondencia {

   /** Devuelve una tabla para umbralizar los datos
    * @param corte valor de umbralizacion
    * @return la tabla como un vector de enteros
    */
   public static int[] tablaUmbral(int corte) {
      int[] b = new int[256];
      for (int i = 0; i < 256; i++)
         if (i <= corte)
            b[i] = 0;
         else
            b[i] = 255;
      return b;
   }

   /** Devuelve una tabla para realizar un escalado 
    * de los datos
    * @param min valor al que corresponde el 0
    * @param max valor al que corresponde el 255
    * @return la tabla como un vector de enteros
    */
   public static int[] tablaEscala(int min, int max) {
      int[] b = new int[256];
      for (int i = 0; i < 255; i++)
         b[i] = (((max - min) * i) / 255 + min);
      return b;
   }
}
